Loading...
Searching...
No Matches
diutils.h File Reference

type definitions, constants and helper functions for the dcmimgle/dcmimage module More...

## Classes

struct | SP_Interpretation
| structure for photometric string and related constant More...
struct | SB_BitmapFileHeader
| structure for BMP bitmap file header More...
struct | SB_BitmapInfoHeader
| structure for BMP bitmap info header More...
class | DicomImageClass
| Class comprising several global functions and constants. More...

## Enumerations

enum | EP_Interpretation { EPI_Unknown , EPI_Missing , EPI_Monochrome1 , EPI_Monochrome2 , EPI_PaletteColor , EPI_RGB , EPI_HSV , EPI_ARGB , EPI_CMYK , EPI_YBR_Full , EPI_YBR_Full_422 , EPI_YBR_Partial_422 }
| constants for photometric interpretation More...
enum | EP_Representation { EPR_Uint8 , EPR_MinUnsigned = EPR_Uint8 , EPR_Sint8 , EPR_MinSigned = EPR_Sint8 , EPR_Uint16 , EPR_Sint16 , EPR_Uint32 , EPR_MaxUnsigned = EPR_Uint32 , EPR_Sint32 , EPR_MaxSigned = EPR_Sint32 }
| internal representation of pixel data More...
enum | EI_Status { EIS_Normal , EIS_NoDataDictionary , EIS_InvalidDocument , EIS_MissingAttribute , EIS_InvalidValue , EIS_NotSupportedValue , EIS_MemoryFailure , EIS_InvalidImage , EIS_OtherError }
| image status code More...
enum | EM_Overlay { EMO_Default , EMO_Replace , EMO_Graphic = EMO_Replace , EMO_ThresholdReplace , EMO_Complement , EMO_InvertBitmap , EMO_RegionOfInterest , EMO_BitmapShutter }
| overlay modes. More...
enum | EF_VoiLutFunction { EFV_Default , EFV_Linear , EFV_Sigmoid }
| VOI LUT functions. More...
enum | ES_PresentationLut { ESP_Default , ESP_Identity , ESP_Inverse , ESP_LinOD }
| presentation LUT shapes More...
enum | EP_Polarity { EPP_Normal , EPP_Reverse }
| polarity More...
enum | EL_BitsPerTableEntry { ELM_UseValue , ELM_IgnoreValue , ELM_CheckValue }
| bits per table entry modes. More...
enum | EW_WindowType { EWT_none , EWT_window_from_file , EWT_voi_lut_from_file , EWT_window_minmax , EWT_window_minmax_n , EWT_window_minmax_roi , EWT_window_histogram , EWT_window_center_width }
| type of VOI LUT transformation to apply. More...

## Variables

configuration flags
const unsigned long | CIF_AcrNemaCompatibility = 0x0000001
| compatibility with old ACR-NEMA images
const unsigned long | CIF_WrongPaletteAttributeTags = 0x0000002
| accept wrong palette attribute tags
const unsigned long | CIF_MayDetachPixelData = 0x0000004
| element pixel data may be detached if it is no longer needed by DicomImage
const unsigned long | CIF_UsePresentationState = 0x0000008
| use presentation state instead of 'built-in' LUTs & overlays
const unsigned long | CIF_KeepYCbCrColorModel = 0x0000010
| don't convert YCbCr (Full and Full 4:2:2) color images to RGB
const unsigned long | CIF_TakeOverExternalDataset = 0x0000020
| take responsibility for the given external DICOM dataset, i.e. delete it on destruction
const unsigned long | CIF_IgnoreModalityTransformation = 0x0000040
| ignore modality transformation (rescale slope/intercept or LUT) stored in the dataset
const unsigned long | CIF_IgnoreModalityLutBitDepth = 0x0000080
| ignore third value of the modality LUT descriptor, determine bit depth automatically
const unsigned long | CIF_CheckLutBitDepth = 0x0000100
| check third value of the LUT descriptor, compare with with expected bit depth based on LUT data
const unsigned long | CIF_UseAbsolutePixelRange = 0x0000200
| use absolute (possible) pixel range for determining the internal representation (monochrome only)
const unsigned long | CIF_UsePartialAccessToPixelData = 0x0000400
| use partial access to pixel data, i.e.
const unsigned long | CIF_DecompressCompletePixelData = 0x0000800
| always decompress complete pixel data when processing an image, i.e. even if partial access is used
const unsigned long | CIF_NeverAccessEmbeddedOverlays = 0x0001000
| never access embedded overlays since this requires to load and uncompress the complete pixel data

## Detailed Description

type definitions, constants and helper functions for the dcmimgle/dcmimage module

## Class Documentation

## SP_Interpretation

struct SP_Interpretation

structure for photometric string and related constant

Class Members
const char * | DefinedTerm | defined term according to the DICOM standard
const char * | Name | string (name of the color model without spaces and underscores)
EP_Interpretation | Type | integer constant

## SB_BitmapFileHeader

struct SB_BitmapFileHeader

structure for BMP bitmap file header

Class Members
Uint32 | bfOffBits | offset from the beginning of the file to the bitmap data (in bytes)
Uint16 | bfReserved1 | reserved, should be '0'
Uint16 | bfReserved2 | reserved, should be '0'
Uint32 | bfSize | file size in bytes
char | bfType[2] | signature, must always be 'BM'

## SB_BitmapInfoHeader

struct SB_BitmapInfoHeader

structure for BMP bitmap info header

Class Members
Uint16 | biBitCount | bits per pixel, supported values: 8 = color palette with 256 entries, 24 = true color
Uint32 | biClrImportant | number of important colors, '0' means all
Uint32 | biClrUsed | number of actually used colors, if '0' the number of colors is calculated using 'biBitCount'
Uint32 | biCompression | type of compression, support value: 0 = BI_RGB, no compression
Sint32 | biHeight | height of the image (in pixels)
Uint16 | biPlanes | number of planes, usually '1'
Uint32 | biSize | size of the BitmapInfoHeader, usually '40'
Uint32 | biSizeImage | size of the image data (in bytes), might be set to '0' if image is uncompressed
Sint32 | biWidth | width of the image (in pixels)
Sint32 | biXPelsPerMeter | horizontal resolution: pixels/meter, usually set to '0'
Sint32 | biYPelsPerMeter | vertical resolution: pixels/meter, usually set to '0'

## Enumeration Type Documentation

## EF_VoiLutFunction

enum EF_VoiLutFunction

VOI LUT functions.

Enumerator
EFV_Default | default function (not explicitly set)
EFV_Linear | function LINEAR
EFV_Sigmoid | function SIGMOID

## EI_Status

enum EI_Status

image status code

Enumerator
EIS_Normal | normal, no error
EIS_NoDataDictionary | data dictionary not found
EIS_InvalidDocument | invalid dataset/file
EIS_MissingAttribute | mandatory attribute missing
EIS_InvalidValue | invalid value for an important attribute
EIS_NotSupportedValue | specified value for an attribute not supported
EIS_MemoryFailure | memory exhausted etc.
EIS_InvalidImage | invalid image, internal error
EIS_OtherError | other error

## EL_BitsPerTableEntry

enum EL_BitsPerTableEntry

bits per table entry modes.

Specifies whether the given value in the LUT descriptor is used.

Enumerator
ELM_UseValue | use given value
ELM_IgnoreValue | ignore given value, use auto detection
ELM_CheckValue | check whether given value is consistent with LUT data

## EM_Overlay

enum EM_Overlay

overlay modes.

This mode is used to define how to display an overlay plane.

Enumerator
EMO_Default | default mode, as stored in the dataset
EMO_Replace | replace mode
EMO_Graphic | graphics overlay
EMO_ThresholdReplace | threshold replace
EMO_Complement | complement
EMO_InvertBitmap | invert the overlay bitmap
EMO_RegionOfInterest | region of interest (ROI)
EMO_BitmapShutter | bitmap shutter, used for GSPS objects

## EP_Interpretation

enum EP_Interpretation

constants for photometric interpretation

Enumerator
EPI_Unknown | unknown, undefined, invalid
EPI_Missing | no element value available
EPI_Monochrome1 | monochrome 1
EPI_Monochrome2 | monochrome 2
EPI_PaletteColor | palette color
EPI_RGB | RGB color.
EPI_HSV | HSV color (retired).
EPI_ARGB | ARGB color (retired).
EPI_CMYK | CMYK color (retired).
EPI_YBR_Full | YCbCr full.
EPI_YBR_Full_422 | YCbCr full 4:2:2.
EPI_YBR_Partial_422 | YCbCr partial 4:2:2.

## EP_Polarity

enum EP_Polarity

polarity

Enumerator
EPP_Normal | NORMAL.
EPP_Reverse | REVERSE (opposite polarity).

## EP_Representation

enum EP_Representation

internal representation of pixel data

Enumerator
EPR_Uint8 | unsigned 8 bit integer
EPR_Sint8 | signed 8 bit integer
EPR_Uint16 | unsigned 16 bit integer
EPR_Sint16 | signed 16 bit integer
EPR_Uint32 | unsigned 32 bit integer
EPR_Sint32 | signed 32 bit integer

## ES_PresentationLut

enum ES_PresentationLut

presentation LUT shapes

Enumerator
ESP_Default | default shape (not explicitly set)
ESP_Identity | shape IDENTITY
ESP_Inverse | shape INVERSE
ESP_LinOD | shape LIN OD

## EW_WindowType

enum EW_WindowType

type of VOI LUT transformation to apply.

Specifies which VOI LUT transformation should be applied to an image.

Enumerator
EWT_none | use given value
EWT_window_from_file | use the n-th VOI window from the image file
EWT_voi_lut_from_file | use the n-th VOI look up table from the image file
EWT_window_minmax | compute VOI window using min-max algorithm
EWT_window_minmax_n | compute VOI window using min-max algorithm ignoring extremes
EWT_window_minmax_roi | compute VOI window using min-max algorithm applied to region of interest
EWT_window_histogram | compute VOI window using Histogram algorithm, ignoring n percent
EWT_window_center_width | compute VOI window using center and width

## Variable Documentation

## CIF_UsePartialAccessToPixelData

const unsigned long CIF_UsePartialAccessToPixelData = 0x0000400

use partial access to pixel data, i.e.

without decompressing or loading a complete multi-frame image. Please note that the use of this flag can cause another copy of the pixel data to be created in memory, e.g. in case the pixel data element value has already been loaded or decompressed completely in memory.

Referenced by DiInputPixelTemplate< T1, T2 >::convert().

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0